#ifndef _NETWORK_H_
#define _NETWORK_H_

// Hilfsprogramme 
#include <iostream>
using namespace std;
#include <cstdlib>

void augij(int* column_indices,double* entries,int* row_offsets,
                      int i,int j,double gamma)
// Augmentiere Kante (i,j) um gamma und (j,i) um -gamma
// Input+Output:  ger. Graph mit Fluss auf den Kanten
//             : column_indices+row_offsets+entries
// Input: Kante (i,j) 
//        gamma
{
  int j1,k,k1,k2;
  k1=row_offsets[i];
  k2=row_offsets[i+1];
  k=k1;
  while (k<k2)
    {
    j1=column_indices[k];
    if (j1==j)
      {
        entries[k]=entries[k]-gamma;
        k=k2;
      }
    k++;
     }
  k1=row_offsets[j];
  k2=row_offsets[j+1];
  k=k1;
  while (k<k2)
    {
    j1=column_indices[k];
    if (j1==i)
      {
        entries[k]=entries[k]+gamma;
        k=k2;
      }
    k++;
     }
}

void aug(int* column_indices,double* entries,int* row_offsets
       ,int* p,double gamma,int s,int t)
// Augmentiere entlang des s-t Weges p (Gespeichert ist
// in p der Vorg\"anger um gamma

// Input+Output: ger. Graph mit Fluss auf den Kanten
//             : column_indices+row_offsets+entries
// input: weg p ueber Vorgaenger gespeichert
//        gamma 
//        s,t start und endknoten
{
  int i,j;
  j=t;
  i=p[t];
  augij(column_indices,entries,row_offsets,i,j,gamma);
  while (i!=s)
    {
      j=i;
      i=p[j]; 
      augij(column_indices,entries,row_offsets,i,j,gamma);
    }
}
#endif
